/***********************************************************************************/
/**	\file				CCircle.cpp
**	\brief				Implementation zur Klasse CCircle
*************************************************************************************
**	Autor:				Christian Roesch
**
**	Erstelldatum:		??.??.2002
**	letzte Aenderung:	??.??.2002
*************************************************************************************
**	-tut nichts-
**
************************************************************************************/


// includes
#include "CCircle.h"

// Methoden-Definitionen

bool CCircle::Intersect( DRay* pRay, float& fDist )
{
    float fDistX= pRay->m_Start.m_fX - m_vecMid.m_fX;
    float fDistY= pRay->m_Start.m_fY - m_vecMid.m_fY;
    float fDistSquared= fDistX * fDistX + fDistY * fDistY;

    if ( fDistSquared <= m_fSqrRadius )
    {
        fDist= 0.0f;
        return true;
    }

    float fPointDist = fDistX * pRay->m_Dir.m_fY -
                       fDistY * pRay->m_Dir.m_fX;

    if( fabs(fPointDist) > m_fRadius )
    {
        return false;
    }

    fDist= fDistX * pRay->m_Dir.m_fX +
           fDistY * pRay->m_Dir.m_fY;
    return true;
}

void CCircle::SetParams( float fRadius,
                         float fPosX,
                         float fPosY )
{
    m_fRadius= fRadius;
    m_fSqrRadius= m_fRadius * m_fRadius;

    m_vecMid.m_fX= fPosX;
    m_vecMid.m_fY= fPosY;
}

bool CCircle::Visible ( DVektor& mid,
                        float fRadius,
                        DVektor& norm1,
                        DVektor& norm2)
{
    float fDist1;
    float fDist2;

    float fDistX= m_vecMid.m_fX - mid.m_fX;
    float fDistY= m_vecMid.m_fY - mid.m_fY;

    fDist1= norm1.m_fX * ( fDistX ) +
            norm1.m_fY * ( fDistY );
    fDist2= norm2.m_fX * ( fDistX ) +
            norm2.m_fY * ( fDistY );

    if( fDist1 - m_fRadius > fRadius && fDist2 - m_fRadius > fRadius)
    {
        return false;
    }

    fRadius= -fRadius;

    if( fDist1 + m_fRadius < fRadius && fDist2 + m_fRadius < fRadius)
    {
        return false;
    }

    return true;
}

/************************************************************************************
**	Ende der Datei:		CCircle.cpp
************************************************************************************/

