/***********************************************************************************/
/**	\file				CLine.cpp
**	\brief				Implementation zur Klasse CLine
*************************************************************************************
**	Autor:				Christian Roesch
**
**	Erstelldatum:		??.??.2002
**	letzte Aenderung:	??.??.2002
*************************************************************************************
**	-tut nichts-
**
************************************************************************************/


// includes
#include "CLine.h"

// Methoden-Definitionen

bool CLine::Intersect( DRay* pRay, float& fDist )
{
    // a1= m_vecDir.m_fX
    // b1= m_vecDir.m_fY
    // a2= - pRay->m_Dir.m_fX
    // b2= - pRay->m_Dir.m_fY
    // c1= m_vecStart.m_fX - pRay->m_Start.m_fX
    // c2= m_vecStart.m_fY - pRay->m_Start.m_fY
    float fD= pRay->m_Dir.m_fX * m_vecDir.m_fY
            - m_vecDir.m_fX * pRay->m_Dir.m_fY;

    if ( fabs(fD) < 0.001f )
    {
        return false;
    }
    float fHit= ( m_vecStart.m_fX - pRay->m_Start.m_fX ) * pRay->m_Dir.m_fY
                - pRay->m_Dir.m_fX * ( m_vecStart.m_fY - pRay->m_Start.m_fY );

    fD= 1.0f / fD;
    fHit*= fD;

    if( fHit >= 1.0f || fHit <= 0.0f)
    {
        return false;
    }

    fDist= m_vecDir.m_fX * ( m_vecStart.m_fY - pRay->m_Start.m_fY )
         - ( m_vecStart.m_fX - pRay->m_Start.m_fX ) * m_vecDir.m_fY;
    fDist*= fD;
    return true;
}

void CLine::SetStart( float fPosX,
                      float fPosY )
{
    m_vecStart.m_fX= fPosX;
    m_vecStart.m_fY= fPosY;
}

void CLine::SetEnd( float fPosX,
                      float fPosY )
{
    m_vecDir.m_fX= fPosX - m_vecStart.m_fX;
    m_vecDir.m_fY= fPosY - m_vecStart.m_fY;
}

void CLine::SetDir( float fDirX,
                      float fDirY )
{
    m_vecDir.m_fX= fDirX;
    m_vecDir.m_fY= fDirY;
}

bool CLine::Visible ( DVektor& mid,
                        float fRadius,
                        DVektor& norm1,
                        DVektor& norm2)
{
    float fDist1;
    float fDist2;
    float fDist1b;
    float fDist2b;

    float fDistX= m_vecStart.m_fX - mid.m_fX;
    float fDistY= m_vecStart.m_fY - mid.m_fY;
    float fDistXb= fDistX + m_vecDir.m_fX;
    float fDistYb= fDistY + m_vecDir.m_fY;

    fDist1= norm1.m_fX * ( fDistX ) +
            norm1.m_fY * ( fDistY );
    fDist2= norm2.m_fX * ( fDistX ) +
            norm2.m_fY * ( fDistY );
    fDist1b= norm1.m_fX * ( fDistXb ) +
            norm1.m_fY * ( fDistYb );
    fDist2b= norm2.m_fX * ( fDistXb ) +
            norm2.m_fY * ( fDistYb );

    if( fDist1 > fRadius && fDist2 > fRadius &&
        fDist1b > fRadius && fDist2b > fRadius)
    {
        return false;
    }

    fRadius= -fRadius;

    if( fDist1 < fRadius && fDist2 < fRadius &&
        fDist1b < fRadius && fDist2b < fRadius)
    {
        return false;
    }

    return true;
}

/************************************************************************************
**	Ende der Datei:		CLine.cpp
************************************************************************************/

