#include <windows.h>
#include <mmsystem.h>
#include <fstream>
#include <string>
#include <time.h>

#include "CRenderTarget.h"
#include "DVektor.h"
#include "CObjektList.h"
#include "CCircle.h"
#include "CLine.h"
#include "CRender.h"

#include <stdio.h>
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library

#ifndef CDS_FULLSCREEN							// CDS_FULLSCREEN Is Not Defined By Some
#define CDS_FULLSCREEN 4						// Compilers. By Defining It This Way,
#endif									// We Can Avoid Errors

HDC			hDC=NULL;		// Private GDI Device Context
HGLRC		hRC=NULL;		// Permanent Rendering Context
HWND		hWnd=NULL;		// Holds Our Window Handle
HINSTANCE	hInstance;		// Holds The Instance Of The Application

bool	active=TRUE;		// Window Active Flag Set To TRUE By Default
bool	fullscreen=TRUE;	// Fullscreen Flag Set To Fullscreen Mode By Default

int siScreenSizeX;
int siScreenSizeY;
int siTextureSize;
float fPictureSize;
bool bInterpolated;
int siBitsPerPixel;

GLuint	texture[1];			// Storage For One Texture ( NEW )

CObjektList* g_polMain;
CRenderTarget* g_prtMain;
CRender* g_pRender;

CObjektList g_ol2D;
CObjektList g_olXMas;
CObjektList g_olCC;
CObjektList g_olBL;
CObjektList g_olSpot;
CObjektList g_olLL;
CObjektList g_olRL;
CObjektList g_olPulse;
CObjektList g_olEnd1;
CObjektList g_olEnd2;

DWORD dwTimeElapsed;
DWORD dwLastTimeLastTick;

int siEffekt= 0;

void CreateObjects ()
{
    CCircle* pCircle;
    CLine* pLine;

    pCircle= new CCircle;
    pCircle->SetParams( 0.5f, -1.8f, -1.5f );
    pCircle->SetColor( 240, 240, 240 );
    pCircle->SetFallOff( 0.01f );
    g_olXMas.AddObjekt( pCircle );

    pLine= new CLine;
    pLine->SetStart( -1.2f, -0.5f );
    pLine->SetEnd( -0.5f, 0.5f );
    pLine->SetColor( 128, 0, 0 );
    pLine->SetFallOff( 10.0f );
    g_olXMas.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( -1.2f, 0.5f );
    pLine->SetEnd( -0.5f, -0.5f );
    pLine->SetColor( 128, 0, 0 );
    pLine->SetFallOff( 10.0f );
    g_olXMas.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( -0.4f, -0.1f );
    pLine->SetEnd( -0.4f, 0.5f );
    pLine->SetColor( 128, 0, 0 );
    pLine->SetFallOff( 10.0f );
    g_olXMas.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( -0.4f, 0.0f );
    pLine->SetEnd( 0.4f, 0.0f );
    pLine->SetColor( 128, 0, 0 );
    pLine->SetFallOff( 10.0f );
    g_olXMas.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( 0.0f, 0.0f );
    pLine->SetEnd( 0.0f, 0.5f );
    pLine->SetColor( 128, 0, 0 );
    pLine->SetFallOff( 10.0f );
    g_olXMas.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( 0.4f, 0.0f );
    pLine->SetEnd( 0.4f, 0.5f );
    pLine->SetColor( 128, 0, 0 );
    pLine->SetFallOff( 10.0f );
    g_olXMas.AddObjekt( pLine );

    pCircle= new CCircle;
    pCircle->SetParams( 0.25f, 0.75f, 0.25f );
    pCircle->SetColor( 128, 0, 0 );
    pCircle->SetFallOff( 5.0f );
    g_olXMas.AddObjekt( pCircle );

    pLine= new CLine;
    pLine->SetStart( 1.0f, 0.0f );
    pLine->SetEnd( 1.0f, 0.5f );
    pLine->SetColor( 128, 0, 0 );
    pLine->SetFallOff( 10.0f );
    g_olXMas.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( 1.7f, -0.3f );
    pLine->SetEnd( 1.1f, 0.1f );
    pLine->SetColor( 128, 0, 0 );
    pLine->SetFallOff( 10.0f );
    g_olXMas.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( 1.1f, 0.1f );
    pLine->SetEnd( 1.6f, 0.4f );
    pLine->SetColor( 128, 0, 0 );
    pLine->SetFallOff( 10.0f );
    g_olXMas.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( 1.6f, 0.4f );
    pLine->SetEnd( 0.9f, 0.7f );
    pLine->SetColor( 128, 0, 0 );
    pLine->SetFallOff( 10.0f );
    g_olXMas.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( 1.6f, 0.4f );
    pLine->SetEnd( 0.9f, 0.7f );
    pLine->SetColor( 128, 0, 0 );
    pLine->SetFallOff( 10.0f );
    g_olXMas.AddObjekt( pLine );

    pCircle= new CCircle;
    pCircle->SetParams( 4.0f, 0.0f, 4.0f );
    pCircle->SetColor( 232, 185, 45 );
    pCircle->SetFallOff( 0.05f );
    g_ol2D.AddObjekt( pCircle );

    pLine= new CLine;
    pLine->SetStart( 1.5f, -0.3f );
    pLine->SetEnd( 1.5f, 0.2f );
    pLine->SetColor( 32, 96, 160 );
    pLine->SetFallOff( 40.0f );
    g_ol2D.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( 1.25f, -0.05f );
    pLine->SetEnd( 1.5f, 0.2f );
    pLine->SetColor( 32, 96, 160 );
    pLine->SetFallOff( 40.0f );
    g_ol2D.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( 1.5f, -0.3f );
    pLine->SetEnd( 1.25f, -0.05f );
    pLine->SetColor( 32, 96, 160 );
    pLine->SetFallOff( 40.0f );
    g_ol2D.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( 1.7f, -0.3f );
    pLine->SetEnd( 1.7f, 0.2f );
    pLine->SetColor( 32, 96, 160 );
    pLine->SetFallOff( 40.0f );
    g_ol2D.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( 1.95f, -0.05f );
    pLine->SetEnd( 1.7f, 0.2f );
    pLine->SetColor( 32, 96, 160 );
    pLine->SetFallOff( 40.0f );
    g_ol2D.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( 1.7f, -0.3f );
    pLine->SetEnd( 1.95f, -0.05f );
    pLine->SetColor( 32, 96, 160 );
    pLine->SetFallOff( 40.0f );
    g_ol2D.AddObjekt( pLine );

    pCircle= new CCircle;
    pCircle->SetParams( 0.45f, 0.0f, 0.7f );
    pCircle->SetColor( 224, 0, 0 );
    pCircle->SetFallOff( 0.05f );
    g_olCC.AddObjekt( pCircle );

    pCircle= new CCircle;
    pCircle->SetParams( 0.45f, -0.606f, -0.35f );
    pCircle->SetColor( 0, 224, 0 );
    pCircle->SetFallOff( 0.05f );
    g_olCC.AddObjekt( pCircle );

    pCircle= new CCircle;
    pCircle->SetParams( 0.45f, 0.606f, -0.35f );
    pCircle->SetColor( 0, 0, 224 );
    pCircle->SetFallOff( 0.05f );
    g_olCC.AddObjekt( pCircle );

    pCircle= new CCircle;
    pCircle->SetParams( 0.23f, 0.0f, 0.0f );
    pCircle->SetColor( 0, 0, 0 );
    pCircle->SetFallOff( 100.0f );
    g_olCC.AddObjekt( pCircle );

    pCircle= new CCircle;
    pCircle->SetParams( 0.1f, 0.0f, 16.0f );
    pCircle->SetColor( 224, 224, 224 );
    pCircle->SetFallOff( 0.1f );
    g_olBL.AddObjekt( pCircle );

    pLine= new CLine;
    pLine->SetStart( 0.15f, -0.075f );
    pLine->SetEnd( 0.15f, 0.075f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olBL.AddObjekt( pLine );
    pLine= new CLine;
    pLine->SetStart( 0.3f, 0.075f );
    pLine->SetEnd( 0.15f, 0.075f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olBL.AddObjekt( pLine );
    pLine= new CLine;
    pLine->SetStart( 0.15f, -0.075f );
    pLine->SetEnd( 0.3f, -0.075f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olBL.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( -0.15f, 0.1f );
    pLine->SetEnd( -0.15f, 0.25f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olBL.AddObjekt( pLine );
    pLine= new CLine;
    pLine->SetStart( -0.3f, 0.25f );
    pLine->SetEnd( -0.15f, 0.25f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olBL.AddObjekt( pLine );
    pLine= new CLine;
    pLine->SetStart( -0.15f, 0.1f );
    pLine->SetEnd( -0.3f, 0.1f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olBL.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( -0.15f, -0.1f );
    pLine->SetEnd( -0.15f, -0.25f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olBL.AddObjekt( pLine );
    pLine= new CLine;
    pLine->SetStart( -0.3f, -0.25f );
    pLine->SetEnd( -0.15f, -0.25f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olBL.AddObjekt( pLine );
    pLine= new CLine;
    pLine->SetStart( -0.15f, -0.1f );
    pLine->SetEnd( -0.3f, -0.1f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olBL.AddObjekt( pLine );

    pCircle= new CCircle;
    pCircle->SetParams( 0.1f, 0.0f, 0.0f );
    pCircle->SetColor( 0, 0, 0 );
    pCircle->SetFallOff( 0.01f );
    g_olSpot.AddObjekt( pCircle );

    pLine= new CLine;
    pLine->SetStart( -0.15f, -0.15f );
    pLine->SetEnd( 0.15f, -0.15f );
    pLine->SetColor( 0, 32, 32 );
    pLine->SetFallOff( 40.0f );
    g_olSpot.AddObjekt( pLine );
    pLine= new CLine;
    pLine->SetStart( -0.15f, -0.15f );
    pLine->SetEnd( -0.15f, 0.15f );
    pLine->SetColor( 0, 32, 32 );
    pLine->SetFallOff( 40.0f );
    g_olSpot.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( 0.25f, 0.25f );
    pLine->SetEnd( 0.25f, 0.4f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olSpot.AddObjekt( pLine );
    pLine= new CLine;
    pLine->SetStart( 0.25f, 0.25f );
    pLine->SetEnd( 0.4f, 0.25f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olSpot.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( -0.25f, -0.25f );
    pLine->SetEnd( -0.25f, -0.4f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olSpot.AddObjekt( pLine );
    pLine= new CLine;
    pLine->SetStart( -0.25f, -0.25f );
    pLine->SetEnd( -0.4f, -0.25f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olSpot.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( 0.25f, -0.25f );
    pLine->SetEnd( 0.25f, -0.4f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olSpot.AddObjekt( pLine );
    pLine= new CLine;
    pLine->SetStart( 0.25f, -0.25f );
    pLine->SetEnd( 0.4f, -0.25f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olSpot.AddObjekt( pLine );

    pLine= new CLine;
    pLine->SetStart( -0.25f, 0.25f );
    pLine->SetEnd( -0.25f, 0.4f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olSpot.AddObjekt( pLine );
    pLine= new CLine;
    pLine->SetStart( -0.25f, 0.25f );
    pLine->SetEnd( -0.4f, 0.25f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 40.0f );
    g_olSpot.AddObjekt( pLine );

    pCircle= new CCircle;
    pCircle->SetParams( 0.15f, 1000.0f, 0.3f );
    pCircle->SetColor( 224, 0, 0 );
    pCircle->SetFallOff( 0.01f );
    g_olLL.AddObjekt( pCircle );
    pCircle= new CCircle;
    pCircle->SetParams( 0.15f, 0.0f, -0.3f );
    pCircle->SetColor( 0, 224, 0 );
    pCircle->SetFallOff( 0.01f );
    g_olLL.AddObjekt( pCircle );

    pLine= new CLine;
    pLine->SetStart( -0.075f, 0.0f );
    pLine->SetEnd( 0.075f, 0.0f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 4.0f );
    g_olLL.AddObjekt( pLine );
    pLine= new CLine;
    pLine->SetStart( -0.225f, 0.0f );
    pLine->SetEnd( -0.375f, 0.0f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 4.0f );
    g_olLL.AddObjekt( pLine );
    pLine= new CLine;
    pLine->SetStart( 0.225f, 0.0f );
    pLine->SetEnd( 0.375f, 0.0f );
    pLine->SetColor( 0, 0, 0 );
    pLine->SetFallOff( 4.0f );
    g_olLL.AddObjekt( pLine );

    pCircle= new CCircle;
    pCircle->SetParams( 0.04f, 0.23f, -20.0f );
    pCircle->SetColor( 111, 73, 40 );
    pCircle->SetFallOff( 100.0f );
    g_olRL.AddObjekt( pCircle );
    pCircle= new CCircle;
    pCircle->SetParams( 0.04f, -0.23f, -20.0f );
    pCircle->SetColor( 111, 73, 40 );
    pCircle->SetFallOff( 100.0f );
    g_olRL.AddObjekt( pCircle );
    pCircle= new CCircle;
    pCircle->SetParams( 0.04f, -0.23f, -20.0f );
    pCircle->SetColor( 111, 73, 40 );
    pCircle->SetFallOff( 100.0f );
    g_olRL.AddObjekt( pCircle );
    pCircle= new CCircle;
    pCircle->SetParams( 0.04f, -0.23f, -20.0f );
    pCircle->SetColor( 111, 73, 40 );
    pCircle->SetFallOff( 100.0f );
    g_olRL.AddObjekt( pCircle );

    pLine= new CLine;
    pLine->SetStart( 0.0f, -0.14f );
    pLine->SetEnd( 0.0f, -0.04f );
    pLine->SetColor( 32, 32, 240 );
    pLine->SetFallOff( 0.01f );
    g_olRL.AddObjekt( pLine );
    pLine= new CLine;
    pLine->SetStart( 0.0f, 0.14f );
    pLine->SetEnd( 0.0f, 0.04f );
    pLine->SetColor( 240, 32, 32 );
    pLine->SetFallOff( 0.01f );
    g_olRL.AddObjekt( pLine );

    pCircle= new CCircle;
    pCircle->SetParams( 0.05f, 0.0f, 0.05f );
    pCircle->SetColor( 240, 240, 240 );
    pCircle->SetFallOff( 0.1f );
    g_olPulse.AddObjekt( pCircle );

    pLine= new CLine;
    pLine->SetStart( -0.9f, -0.2f );
    pLine->SetEnd( -0.5f, -0.2f );
    pLine->SetColor( 0, 48, 0 );
    pLine->SetFallOff( 30.0f );
    g_olPulse.AddObjekt( pLine );
    pLine= new CLine;
    pLine->SetStart( -0.2f, -0.2f );
    pLine->SetEnd( 0.2f, -0.2f );
    pLine->SetColor( 0, 48, 0 );
    pLine->SetFallOff( 30.0f );
    g_olPulse.AddObjekt( pLine );
    pLine= new CLine;
    pLine->SetStart( 0.5f, -0.2f );
    pLine->SetEnd( 0.9f, -0.2f );
    pLine->SetColor( 0, 48, 0 );
    pLine->SetFallOff( 30.0f );
    g_olPulse.AddObjekt( pLine );

    pCircle= new CCircle;
    pCircle->SetParams( 2.00f, 10.0f, 0.00f );
    pCircle->SetColor( 240, 240, 240 );
    pCircle->SetFallOff( 0.001f );
    g_olEnd1.AddObjekt( pCircle );
    pCircle= new CCircle;
    pCircle->SetParams( 2.00f, -10.0f, 0.00f );
    pCircle->SetColor( 240, 240, 240 );
    pCircle->SetFallOff( 0.001f );
    g_olEnd1.AddObjekt( pCircle );
    pCircle= new CCircle;
    pCircle->SetParams( 2.00f, 0.0f, 15.00f );
    pCircle->SetColor( 240, 240, 240 );
    pCircle->SetFallOff( 0.001f );
    g_olEnd1.AddObjekt( pCircle );
    pCircle= new CCircle;
    pCircle->SetParams( 2.00f, 0.0f, -15.00f );
    pCircle->SetColor( 240, 240, 240 );
    pCircle->SetFallOff( 0.001f );
    g_olEnd1.AddObjekt( pCircle );

    pCircle= new CCircle;
    pCircle->SetParams( 4.00f, 0.0f, 0.00f );
    pCircle->SetColor( 240, 240, 240 );
    pCircle->SetFallOff( 0.10f );
    g_olEnd2.AddObjekt( pCircle );
}

void DestroyObjects ()
{
    g_olXMas.Destroy();
    g_ol2D.Destroy();
    g_olCC.Destroy();
    g_olBL.Destroy();
    g_olSpot.Destroy();
    g_olLL.Destroy();
    g_olRL.Destroy();
    g_olPulse.Destroy();
    g_olEnd1.Destroy();
    g_olEnd2.Destroy();
}

bool Animate( DVektor& mid,
              DVektor& mat1,
              DVektor& mat2,
              float& fScale)
{
    mid.m_fX=0.0f;
    mid.m_fY=0.0f;
    mat1.m_fX=1.0f;
    mat1.m_fY=0.0f;
    mat2.m_fX=0.0f;
    mat2.m_fY=1.0f;
    fScale= 1.0f;

    switch( siEffekt )
    {
    case 0:
        g_polMain= &g_ol2D;
        mid.m_fX=-2.5f + dwTimeElapsed * 0.0005f;
        fScale= 1.1f;

        if ( dwTimeElapsed > 8000 )
        {
            mid.m_fX= 1.5f;
            siEffekt++;
        };
        break;
    case 1:
        mid.m_fX= 1.5f;
        fScale= 1.1f;

        if ( dwTimeElapsed > 10000 )
        {
            siEffekt++;
        };
        break;
    case 2:
        mid.m_fX= 1.5f;
        fScale= 1.1f;

        {
            float fW= 0.00025f* (dwTimeElapsed - 10000);
            float fAW= 1.0f - fW;
            ((CLine*)(g_ol2D.GetObjekt( 1 )))->SetStart( 1.5f * fAW + 1.55f * fW , -0.3f * fAW - 0.2f * fW );
            ((CLine*)(g_ol2D.GetObjekt( 1 )))->SetEnd( 1.5f * fAW + 1.3f * fW, 0.2f * fAW + 0.1f * fW);

            ((CLine*)(g_ol2D.GetObjekt( 2 )))->SetStart( 1.25f  * fAW + 1.3f * fW , -0.05f  * fAW + 0.1f * fW );
            ((CLine*)(g_ol2D.GetObjekt( 2 )))->SetEnd( 1.5f * fAW + 1.6f * fW, 0.2f * fAW + 0.25f * fW);

            ((CLine*)(g_ol2D.GetObjekt( 3 )))->SetStart( 1.5f * fAW + 1.55f * fW, -0.3f * fAW - 0.2f * fW );
            ((CLine*)(g_ol2D.GetObjekt( 3 )))->SetEnd( 1.25f * fAW + 1.25f * fW, -0.05f * fAW + -0.35f * fW);
        }

        if ( dwTimeElapsed > 14000 )
        {
            ((CLine*)(g_ol2D.GetObjekt( 1 )))->SetStart( 1.55f , -0.2f );
            ((CLine*)(g_ol2D.GetObjekt( 1 )))->SetEnd( 1.3f, 0.1f );

            ((CLine*)(g_ol2D.GetObjekt( 2 )))->SetStart( 1.3f, 0.1f );
            ((CLine*)(g_ol2D.GetObjekt( 2 )))->SetEnd( 1.6f, 0.25f );

            ((CLine*)(g_ol2D.GetObjekt( 3 )))->SetStart( 1.55f, -0.2f );
            ((CLine*)(g_ol2D.GetObjekt( 3 )))->SetEnd( 1.25f, -0.35f );

            siEffekt++;
        };
        break;
    case 3:
        mid.m_fX= 1.5f;
        fScale= 1.1f;

        if ( dwTimeElapsed > 16000 )
        {
            siEffekt++;
        };
        break;
    case 4:
        mid.m_fX= 1.5f +(float)(dwTimeElapsed - 16000) * 0.0001f;
        fScale= 1.1f + (float)(dwTimeElapsed - 16000) * 0.001f;
        mid.m_fY= (float)(dwTimeElapsed - 16000) * 0.0003f;
        mid.m_fY*= -mid.m_fY;

        if ( dwTimeElapsed > 30000 )
        {
            siEffekt++;
            g_polMain= &g_olCC;
            fScale= 0.25f;
        };
        break;
    case 5:
        fScale= 0.2f + (float)(dwTimeElapsed - 30000) * 0.0005f;

        mat1.m_fX= sin( (float)(dwTimeElapsed - 30000) * 0.003f );
        mat1.m_fY= cos( (float)(dwTimeElapsed - 30000) * 0.003f );
        mat2.m_fX= cos( (float)(dwTimeElapsed - 30000) * 0.003f );
        mat2.m_fY= -sin( (float)(dwTimeElapsed - 30000) * 0.003f );
        if ( dwTimeElapsed > 38000 )
        {
            siEffekt++;
        };
        break;
    case 6:
        fScale= 4.2f - (float)(dwTimeElapsed - 38000) * 0.0005f;
        mat1.m_fX= sin( (float)(dwTimeElapsed - 30000) * 0.003f );
        mat1.m_fY= cos( (float)(dwTimeElapsed - 30000) * 0.003f );
        mat2.m_fX= cos( (float)(dwTimeElapsed - 30000) * 0.003f );
        mat2.m_fY= -sin( (float)(dwTimeElapsed - 30000) * 0.003f );
        if ( dwTimeElapsed > 46000 )
        {
            siEffekt++;
            g_polMain= &g_olBL;
        };
        break;
    case 7:
        {
            float fTmp= ((float)(dwTimeElapsed) - 54000.0f) * 0.000125f;
            fTmp= fTmp * fTmp;
            if ( dwTimeElapsed > 54000 )
            {
                fTmp= -fTmp;
            };
            ((CCircle*)(g_olBL.GetObjekt( 0 )))->SetParams( 0.1f, 0.0f, fTmp );
        }
        if ( dwTimeElapsed > 64000 )
        {
            siEffekt++;
            g_polMain= &g_olSpot;
        };
    case 8:
        if ( dwTimeElapsed < 70000 )
        {
            int iTmp= int(((float)(dwTimeElapsed) - 64000.0f) * 0.04f);
            g_olSpot.GetObjekt( 0 )->SetColor( iTmp, iTmp, iTmp );
        }
        else if ( dwTimeElapsed > 90000 )
        {
            int iTmp= 240 - int(((float)(dwTimeElapsed) - 90000.0f) * 0.04f);
            g_olSpot.GetObjekt( 0 )->SetColor( iTmp, iTmp, iTmp );
        }
        else
        {
            g_olSpot.GetObjekt( 0 )->SetColor( 240, 240, 240 );
        }

        {
            float fAngle= ((float)(dwTimeElapsed) - 64000.0f) * 0.0008f;
            float fX1= sin( fAngle - 2.356f ) * 0.2f;
            float fY1= cos( fAngle - 2.356f ) * 0.2f;
            float fX2= sin( fAngle - 0.7854f ) * 0.2f;
            float fY2= cos( fAngle - 0.7854f ) * 0.2f;
            ((CLine*)(g_olSpot.GetObjekt( 1 )))->SetStart( fX1, fY1 );
            ((CLine*)(g_olSpot.GetObjekt( 1 )))->SetEnd( fX2, fY2 );
            ((CLine*)(g_olSpot.GetObjekt( 2 )))->SetStart( fX1, fY1 );
            ((CLine*)(g_olSpot.GetObjekt( 2 )))->SetEnd( -fX2, -fY2 );
        }

        if ( dwTimeElapsed > 96000 )
        {
            siEffekt++;
            g_polMain= &g_olLL;
        };
        break;
    case 9:
        {
            int iTmp= 64 - int( 60 * cos(((float)(dwTimeElapsed) - 96000.0f) * 0.001f ) );
            g_olLL.GetObjekt( 2 )->SetColor( 0, 0, iTmp );
            g_olLL.GetObjekt( 3 )->SetColor( 0, 0, iTmp );
            g_olLL.GetObjekt( 4 )->SetColor( 0, 0, iTmp );

            float fS= sin( ( (float)(dwTimeElapsed) - 96000.0f) * 0.00025f );
            float fC= cos( ( (float)(dwTimeElapsed) - 96000.0f) * 0.00025f );
            if( fabs(fS) < 0.001f )
            {
                fS= 0.001f;
            }
            if( fabs(fC) < 0.001f )
            {
                fC= 0.001f;
            }
            ((CCircle*)(g_olLL.GetObjekt( 0 )))->SetParams( 0.15f, 0.5f * fC / fS, 0.3f );
            ((CCircle*)(g_olLL.GetObjekt( 1 )))->SetParams( 0.15f, 0.5f * fS / fC, -0.3f );
        }
        if ( dwTimeElapsed > 133700 )
        {
            siEffekt++;
        }
        break;
    case 10:
        {
            int iTmp= 64 - int( 60 * cos(((float)(dwTimeElapsed) - 96000.0f) * 0.001f ) );
            g_olLL.GetObjekt( 2 )->SetColor( 0, 0, iTmp );
            g_olLL.GetObjekt( 3 )->SetColor( 0, 0, iTmp );
            g_olLL.GetObjekt( 4 )->SetColor( 0, 0, iTmp );

            float fS= sin( ( (float)(dwTimeElapsed) - 96000.0f) * 0.0005f );
            float fC= cos( ( (float)(dwTimeElapsed) - 96000.0f) * 0.0005f );
            ((CCircle*)(g_olLL.GetObjekt( 1 )))->SetParams( 0.15f, 0.6f * fS , -0.3f * fC);
            fS= sin( ( (float)(dwTimeElapsed) - 96000.0f) * 0.00025f );
            fC= cos( ( (float)(dwTimeElapsed) - 96000.0f) * 0.00025f );
            if( fabs(fS) < 0.001f )
            {
                fS= 0.001f;
            }
            if( fabs(fC) < 0.001f )
            {
                fC= 0.001f;
            }
           ((CCircle*)(g_olLL.GetObjekt( 0 )))->SetParams( 0.15f, -0.5f * fC / fS, -0.3f  );
        }
        if ( dwTimeElapsed > 140000 )
        {
            siEffekt++;
        }
        break;
    case 11:
        {
            int iTmp= 64 - int( 60 * cos(((float)(dwTimeElapsed) - 96000.0f) * 0.001f ) );
            g_olLL.GetObjekt( 2 )->SetColor( 0, 0, iTmp );
            g_olLL.GetObjekt( 3 )->SetColor( 0, 0, iTmp );
            g_olLL.GetObjekt( 4 )->SetColor( 0, 0, iTmp );

            float fS= sin( ( (float)(dwTimeElapsed) - 96000.0f) * 0.0005f );
            float fC= cos( ( (float)(dwTimeElapsed) - 96000.0f) * 0.0005f );
            ((CCircle*)(g_olLL.GetObjekt( 1 )))->SetParams( 0.15f, 0.6f * fS , -0.3f * fC);
            ((CCircle*)(g_olLL.GetObjekt( 0 )))->SetParams( 0.15f, -0.6f * fS , 0.3f * fC );
        }
        if ( dwTimeElapsed > 155000 )
        {
            siEffekt++;
        }
        break;
    case 12:
        {
            int iTmp= 64 - int( 60 * cos(((float)(dwTimeElapsed) - 96000.0f) * 0.001f ) );
            g_olLL.GetObjekt( 2 )->SetColor( 0, 0, iTmp );
            g_olLL.GetObjekt( 3 )->SetColor( 0, 0, iTmp );
            g_olLL.GetObjekt( 4 )->SetColor( 0, 0, iTmp );
            float fW= 0.0001f* (dwTimeElapsed - 155000);
            float fAW= 1.0f - fW;
            ((CLine*)(g_olLL.GetObjekt( 2 )))->SetStart( -0.075f * fAW - 0.09f * fW , 0.14f * fW );
            ((CLine*)(g_olLL.GetObjekt( 2 )))->SetEnd( 0.075f * fAW + 0.09f * fW, 0.0f);

            ((CLine*)(g_olLL.GetObjekt( 3 )))->SetStart( -0.225f  * fAW - 0.09f * fW , -0.14f * fW );
            ((CLine*)(g_olLL.GetObjekt( 3 )))->SetEnd( -0.375f * fAW - 0.09f * fW, 0.14f * fW);

            ((CLine*)(g_olLL.GetObjekt( 4 )))->SetStart( 0.225f * fAW - 0.09f * fW, -0.14f * fW );
            ((CLine*)(g_olLL.GetObjekt( 4 )))->SetEnd( 0.375f * fAW + 0.09f * fW,  0.0f );

            float fS= sin( ( (float)(dwTimeElapsed) - 96000.0f) * 0.0005f );
            float fC= cos( ( (float)(dwTimeElapsed) - 96000.0f) * 0.0005f );
            ((CCircle*)(g_olLL.GetObjekt( 1 )))->SetParams( 0.15f, 0.6f * fS , -0.3f * fC);
            ((CCircle*)(g_olLL.GetObjekt( 0 )))->SetParams( 0.15f, -0.6f * fS , 0.3f * fC );
        }
        if ( dwTimeElapsed > 165000 )
        {
            ((CLine*)(g_olLL.GetObjekt( 2 )))->SetStart( - 0.09f, 0.14f );
            ((CLine*)(g_olLL.GetObjekt( 2 )))->SetEnd( 0.09f, 0.0f);

            ((CLine*)(g_olLL.GetObjekt( 3 )))->SetStart( - 0.09f , -0.14f );
            ((CLine*)(g_olLL.GetObjekt( 3 )))->SetEnd( - 0.09f, 0.14f );

            ((CLine*)(g_olLL.GetObjekt( 4 )))->SetStart( - 0.09f, -0.14f );
            ((CLine*)(g_olLL.GetObjekt( 4 )))->SetEnd( 0.09f,  0.0f );

            siEffekt++;
        }
        break;
    case 13:
        {
            int iTmp= 64 - int( 60 * cos(((float)(dwTimeElapsed) - 96000.0f) * 0.001f ) );
            g_olLL.GetObjekt( 2 )->SetColor( 0, 0, iTmp );
            g_olLL.GetObjekt( 3 )->SetColor( 0, 0, iTmp );
            g_olLL.GetObjekt( 4 )->SetColor( 0, 0, iTmp );

            float fS= sin( ( (float)(dwTimeElapsed) - 96000.0f) * 0.0005f );
            float fC= cos( ( (float)(dwTimeElapsed) - 96000.0f) * 0.0005f );
            ((CCircle*)(g_olLL.GetObjekt( 1 )))->SetParams( 0.15f, 0.6f * fS , -0.3f * fC);
            ((CCircle*)(g_olLL.GetObjekt( 0 )))->SetParams( 0.15f, -0.6f * fS , 0.3f * fC );
        }
        if ( dwTimeElapsed > 185250 )
        {
            fScale-= ((float)(dwTimeElapsed) - 185250.0f) * 0.00019f;
        }
        if ( dwTimeElapsed > 190250 )
        {
            siEffekt++;
            g_polMain= &g_olRL;
            mid.m_fX= 10.0f;
        }
        break;
    case 14:
        mid.m_fX= ((float)(dwTimeElapsed) - 200000.0f) * 0.000125f;
        mid.m_fX= mid.m_fX * mid.m_fX;
        {
            float fP= ( (float)(dwTimeElapsed - 200000) * 0.0003f ) - 0.75f;
            ((CCircle*)(g_olRL.GetObjekt( 0 )))->SetParams( 0.05f, fP, 0.24f);
            ((CCircle*)(g_olRL.GetObjekt( 1 )))->SetParams( 0.05f, fP, -0.24f);
            fP= ( (float)(dwTimeElapsed - 197500) * 0.0003f ) - 0.75f;
            ((CCircle*)(g_olRL.GetObjekt( 2 )))->SetParams( 0.05f, fP, 0.24f);
            ((CCircle*)(g_olRL.GetObjekt( 3 )))->SetParams( 0.05f, fP, -0.24f);
            float fS= sin( ( (float)(dwTimeElapsed) - 196000.0f) * 0.003f );
            float fC= cos( ( (float)(dwTimeElapsed) - 196000.0f) * 0.003f );
            ((CLine*)(g_olRL.GetObjekt( 4 )))->SetStart( 0.07f * fS , -0.09f - 0.07f * fC);
            ((CLine*)(g_olRL.GetObjekt( 4 )))->SetEnd( -0.07f * fS , -0.09f + 0.07f * fC);
            ((CLine*)(g_olRL.GetObjekt( 5 )))->SetStart( 0.07f * fS , 0.09f + 0.07f * fC);
            ((CLine*)(g_olRL.GetObjekt( 5 )))->SetEnd( -0.07f * fS , 0.09f - 0.07f * fC);
        }
        if ( dwTimeElapsed > 200000 )
        {
            siEffekt++;
        }
        break;
    case 15:
        {
            float fP= ( (float)(dwTimeElapsed % 5000) * 0.0003f ) - 0.75f;
            ((CCircle*)(g_olRL.GetObjekt( 0 )))->SetParams( 0.05f, fP, 0.24f);
            ((CCircle*)(g_olRL.GetObjekt( 1 )))->SetParams( 0.05f, fP, -0.24f);
            fP= ( (float)((dwTimeElapsed + 2500) % 5000) * 0.0003f ) - 0.75f;
            ((CCircle*)(g_olRL.GetObjekt( 2 )))->SetParams( 0.05f, fP, 0.24f);
            ((CCircle*)(g_olRL.GetObjekt( 3 )))->SetParams( 0.05f, fP, -0.24f);
            float fS= sin( ( (float)(dwTimeElapsed) - 196000.0f) * 0.003f );
            float fC= cos( ( (float)(dwTimeElapsed) - 196000.0f) * 0.003f );
            ((CLine*)(g_olRL.GetObjekt( 4 )))->SetStart( 0.07f * fS , -0.09f - 0.07f * fC);
            ((CLine*)(g_olRL.GetObjekt( 4 )))->SetEnd( -0.07f * fS , -0.09f + 0.07f * fC);
            ((CLine*)(g_olRL.GetObjekt( 5 )))->SetStart( 0.07f * fS , 0.09f + 0.07f * fC);
            ((CLine*)(g_olRL.GetObjekt( 5 )))->SetEnd( -0.07f * fS , 0.09f - 0.07f * fC);
        }
        if ( dwTimeElapsed > 220000 )
        {
            siEffekt++;
        }
        break;
    case 16:
        mid.m_fX= ((float)(dwTimeElapsed) - 220000.0f) * 0.0001f;
        mid.m_fX= -mid.m_fX * mid.m_fX;
        {
            float fP= ( (float)(dwTimeElapsed - 220000) * 0.0003f ) - 0.75f;
            ((CCircle*)(g_olRL.GetObjekt( 0 )))->SetParams( 0.05f, fP, 0.24f);
            ((CCircle*)(g_olRL.GetObjekt( 1 )))->SetParams( 0.05f, fP, -0.24f);
            fP= ( (float)(dwTimeElapsed - 217500) * 0.0003f ) - 0.75f;
            ((CCircle*)(g_olRL.GetObjekt( 2 )))->SetParams( 0.05f, fP, 0.24f);
            ((CCircle*)(g_olRL.GetObjekt( 3 )))->SetParams( 0.05f, fP, -0.24f);
            float fS= sin( ( (float)(dwTimeElapsed) - 196000.0f) * 0.003f );
            float fC= cos( ( (float)(dwTimeElapsed) - 196000.0f) * 0.003f );
            ((CLine*)(g_olRL.GetObjekt( 4 )))->SetStart( 0.07f * fS , -0.09f - 0.07f * fC);
            ((CLine*)(g_olRL.GetObjekt( 4 )))->SetEnd( -0.07f * fS , -0.09f + 0.07f * fC);
            ((CLine*)(g_olRL.GetObjekt( 5 )))->SetStart( 0.07f * fS , 0.09f + 0.07f * fC);
            ((CLine*)(g_olRL.GetObjekt( 5 )))->SetEnd( -0.07f * fS , 0.09f - 0.07f * fC);
        }
        if ( dwTimeElapsed > 230000 )
        {
            siEffekt++;
            g_polMain= &g_olPulse;
            mid.m_fY = -10.0f;
        }
        break;
    case 17:
        if ( dwTimeElapsed < 240000 )
        {
            mid.m_fY = ((float)(dwTimeElapsed) - 240000.0f) * 0.00015f;
            mid.m_fY = -mid.m_fY * mid.m_fY;
        }
        if ( dwTimeElapsed > 272000 )
        {
            mid.m_fY = ((float)(dwTimeElapsed) - 272000.0f) * 0.0003f;
            fScale=1.0f - 0.5f * mid.m_fY;
            mid.m_fY = mid.m_fY * mid.m_fY;
        }
        {
            float fP;
            fP= ( (float)((dwTimeElapsed + 1140) % 6000) * 0.00035f ) - 1.3f;
            ((CLine*)(g_olPulse.GetObjekt( 1 )))->SetStart( fP, 0.0f );
            ((CLine*)(g_olPulse.GetObjekt( 1 )))->SetEnd( fP + 0.4f, 0.0f );
            fP= ( (float)((dwTimeElapsed + 3140) % 6000) * 0.00035f ) - 1.3f;
            ((CLine*)(g_olPulse.GetObjekt( 2 )))->SetStart( fP, 0.0f );
            ((CLine*)(g_olPulse.GetObjekt( 2 )))->SetEnd( fP + 0.4f, 0.0f );
            fP= ( (float)((dwTimeElapsed + 5140) % 6000) * 0.00035f ) - 1.3f;
            ((CLine*)(g_olPulse.GetObjekt( 3 )))->SetStart( fP, 0.0f );
            ((CLine*)(g_olPulse.GetObjekt( 3 )))->SetEnd( fP + 0.4f, 0.0f );

            fP= cos( ( (float)(dwTimeElapsed) - 230000.0f) * 0.0004f );
            fP= 1.20f- 1.15f * fabs( fP );
            ((CCircle*)(g_olPulse.GetObjekt( 0 )))->SetParams( fP, 0.0f, fP + 0.2f);

        }
        if ( dwTimeElapsed > 275000 )
        {
            siEffekt++;
            g_polMain= &g_olXMas;
            fScale= 0.2f;
            mid.m_fX= -1.8;
            mid.m_fY= -1.5;
        }
        break;
    case 18:
        mid.m_fX= -1.8f + (float)(dwTimeElapsed - 275000) * 0.00012f ;
        mid.m_fY= -1.5f + (float)(dwTimeElapsed - 275000) * 0.00010f ;
        ((CCircle*)(g_olXMas.GetObjekt( 0 )))->SetParams( 0.5f,
                                                          -1.8f + (float)(dwTimeElapsed - 275000) * 0.00025f,
                                                          -1.5f);
        fScale= 4.0f;
        if ( dwTimeElapsed < 277000 )
        {
            fScale = ((float)(dwTimeElapsed) - 275000.0f) * 0.001f;
            fScale = 0.4f + 1.8f * fScale;
        }
        if ( dwTimeElapsed > 300000 )
        {
            siEffekt++;
            mat2.m_fX= 0.8f;
        };
        break;
    case 19:
        fScale= 4.0f;
        if ( dwTimeElapsed > 302000 )
        {
            siEffekt++;
            mat2.m_fX= 0.8f;
        };
        break;
    case 20:
        fScale= 4.0f;
        if ( dwTimeElapsed > 302500 )
        {
            siEffekt++;
            mat2.m_fX= 0.8f;
        };
        break;
    case 21:
        fScale= 4.0f;
        if ( dwTimeElapsed > 303500 )
        {
            siEffekt++;
            mat2.m_fX= 0.8f;
        };
        break;
    case 22:
        fScale= 4.0f;
        if ( dwTimeElapsed > 305000 )
        {
            siEffekt++;
            g_polMain= &g_olEnd1;
        };
        break;
    case 23:
        if ( dwTimeElapsed > 308000 )
        {
            siEffekt++;
            g_polMain= &g_olEnd2;
        };
        break;
    case 24:
        fScale = ((float)(dwTimeElapsed) - 308000.0f) * 0.01f;
        fScale = 1.0f + fScale * fScale;
        if ( dwTimeElapsed > 312000 )
        {
            siEffekt++;
            return false;
        };
        break;
    }

    return true;
}

void Screenshot(std::string strName)
{
    std::ofstream ofs(strName.c_str(), std::ios::out | std::ios::binary );

    int siScreenX;
    int siScreenY;
    int siOffset= 0;

    for( siScreenY= 0; siScreenY < g_prtMain->GetHeight(); siScreenY++ )
        for( siScreenX= 0; siScreenX < g_prtMain->GetWidth(); siScreenX++ )
        {
            ofs.write( (char*)&(g_prtMain->GetTargetPointer()[siOffset].ucRed),
                       1);
            ofs.write( (char*)&(g_prtMain->GetTargetPointer()[siOffset].ucGreen),
                       1);
            ofs.write( (char*)&(g_prtMain->GetTargetPointer()[siOffset].ucBlue),
                       1);

            siOffset++;
        }
}

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration For WndProc

int LoadGLTextures()									// Load Bitmaps And Convert To Textures
{
	int Status=FALSE;									// Status Indicator

	// Load The Bitmap, Check For Errors, If Bitmap's Not Found Quit
	Status=TRUE;									// Set The Status To TRUE

	glGenTextures(1, &texture[0]);					// Create The Texture

    // Typical Texture Generation Using Data From The Bitmap
	glBindTexture(GL_TEXTURE_2D, texture[0]);
    if (bInterpolated)
    {
	   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
    }
    else
    {
	   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
    }

	return Status;										// Return The Status
}

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
{
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
}

int InitGL(GLvoid)										// All Setup For OpenGL Goes Here
{
	if (!LoadGLTextures())								// Jump To Texture Loading Routine ( NEW )
	{
		return FALSE;									// If Texture Didn't Load Return FALSE
	}

	glEnable(GL_TEXTURE_2D);							// Enable Texture Mapping ( NEW )
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);				// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	//glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);	// Really Nice Perspective Calculations
	return TRUE;										// Initialization Went OK
}

int DrawGLScene(GLvoid)									// Here's Where We Do All The Drawing
{
    DVektor mid;
    DVektor mat1;
    DVektor mat2;
    float fScale;

    if( !Animate( mid, mat1, mat2, fScale ) )
    {
	   return FALSE;
    }

/******************************************************************************/
    g_pRender->Render( *g_polMain,
                       mid,
                       mat1,
                       mat2,
                       fScale );
/******************************************************************************/

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
	glLoadIdentity();									// Reset The View
	glTranslatef(0.0f,0.0f,-5.0f);

	//glRotatef(xrot,1.0f,0.0f,0.0f);
	//glRotatef(yrot,0.0f,1.0f,0.0f);
	//glRotatef(zrot,0.0f,0.0f,1.0f);

    float fTextureOffset=0;
    if( bInterpolated )
    {
        fTextureOffset= 0.5f / (float)siTextureSize;
    }
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, siTextureSize, siTextureSize, 0, GL_RGBA, GL_UNSIGNED_BYTE, g_prtMain->GetTargetPointer());
	glBindTexture(GL_TEXTURE_2D, texture[0]);
	glBegin(GL_QUADS);

		// Front Face
		glTexCoord2f(fTextureOffset, 1.0f - fTextureOffset);
        glVertex3f(-fPictureSize*1.33f, -fPictureSize,  1.0f);
		glTexCoord2f(1.0f - fTextureOffset, 1.0f - fTextureOffset);
        glVertex3f( fPictureSize*1.33f, -fPictureSize,  1.0f);
		glTexCoord2f(1.0f - fTextureOffset, fTextureOffset);
        glVertex3f( fPictureSize*1.33f,  fPictureSize,  1.0f);
		glTexCoord2f(fTextureOffset, fTextureOffset);
        glVertex3f(-fPictureSize*1.33f,  fPictureSize,  1.0f);
		// Back Face

	glEnd();

	return TRUE;										// Keep Going
}

GLvoid KillGLWindow(GLvoid)								// Properly Kill The Window
{
	if (fullscreen)										// Are We In Fullscreen Mode?
	{
		ChangeDisplaySettings(NULL,0);					// If So Switch Back To The Desktop
		ShowCursor(TRUE);								// Show Mouse Pointer
	}

	if (hRC)											// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))			// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;									// Set hInstance To NULL
	}
}

/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/
 
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	WNDCLASS	wc;						// Windows Class Structure
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;			// Set Left Value To 0
	WindowRect.right=(long)width;		// Set Right Value To Requested Width
	WindowRect.top=(long)0;				// Set Top Value To 0
	WindowRect.bottom=(long)height;		// Set Bottom Value To Requested Height

	fullscreen=fullscreenflag;			// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name

	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}
	
	if (fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","ZweiD",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;		// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP;										// Windows Style
		ShowCursor(FALSE);										// Hide Mouse Pointer
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Adjust Window To True Requested Size

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
								"OpenGL",							// Class Name
								title,								// Window Title
								dwStyle |							// Defined Window Style
								WS_CLIPSIBLINGS |					// Required Window Style
								WS_CLIPCHILDREN,					// Required Window Style
								0, 0,								// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Request An RGBA Format
		bits,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))							// Did We Get A Device Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))					// Try To Activate The Rendering Context
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);						// Show The Window
	SetForegroundWindow(hWnd);						// Slightly Higher Priority
	SetFocus(hWnd);									// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);					// Set Up Our Perspective GL Screen

	if (!InitGL())									// Initialize Our Newly Created GL Window
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	return TRUE;									// Success
}

LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle For This Window
							UINT	uMsg,			// Message For This Window
							WPARAM	wParam,			// Additional Message Information
							LPARAM	lParam)			// Additional Message Information
{
	switch (uMsg)									// Check For Windows Messages
	{
		case WM_ACTIVATE:							// Watch For Window Activate Message
		{
			if (!HIWORD(wParam))					// Check Minimization State
			{
				active=TRUE;						// Program Is Active
			}
			else
			{
				active=FALSE;						// Program Is No Longer Active
			}

			return 0;								// Return To The Message Loop
		}

		case WM_SYSCOMMAND:							// Intercept System Commands
		{
			switch (wParam)							// Check System Calls
			{
				case SC_SCREENSAVE:					// Screensaver Trying To Start?
				case SC_MONITORPOWER:				// Monitor Trying To Enter Powersave?
				return 0;							// Prevent From Happening
			}
			break;									// Exit
		}

		case WM_CLOSE:								// Did We Receive A Close Message?
		{
			PostQuitMessage(0);						// Send A Quit Message
			return 0;								// Jump Back
		}

		case WM_KEYDOWN:							// Is A Key Being Held Down?
		{
			SendMessage(hWnd, WM_CLOSE, 0 ,0);		// Send A Quit Message
			return 0;								// Jump Back
		}

		case WM_SIZE:								// Resize The OpenGL Window
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // LoWord=Width, HiWord=Height
			return 0;								// Jump Back
		}
	}

	// Pass All Unhandled Messages To DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

void RenderXMas()
{
    DVektor mid;
    DVektor mat1;
    DVektor mat2;

    mid.m_fX=0.0f;
    mid.m_fY=0.0f;
    mat1.m_fX=1.0f;
    mat1.m_fY=0.0f;
    mat2.m_fX=0.0f;
    mat2.m_fY=1.0f;

    g_pRender->Render( g_olXMas,
                       mid,
                       mat1,
                       mat2,
                       4.2f );
}

void Render2D()
{
    DVektor mid;
    DVektor mat1;
    DVektor mat2;

    mid.m_fX=1.5f;
    mid.m_fY=0.0f;
    mat1.m_fX=1.0f;
    mat1.m_fY=0.0f;
    mat2.m_fX=0.0f;
    mat2.m_fY=1.0f;

    g_pRender->Render( g_ol2D,
                       mid,
                       mat1,
                       mat2,
                       1.1f );
}

void RenderCC()
{
    DVektor mid;
    DVektor mat1;
    DVektor mat2;

    mid.m_fX=0.0f;
    mid.m_fY=0.0f;
    mat1.m_fX=1.0f;
    mat1.m_fY=0.0f;
    mat2.m_fX=0.0f;
    mat2.m_fY=1.0f;

    g_pRender->Render( g_olCC,
                       mid,
                       mat1,
                       mat2,
                       3.0f );
}

void RenderBL()
{
    ((CCircle*)(g_olBL.GetObjekt( 0 )))->SetParams( 0.1f, 0.0f, 0.0f );

    DVektor mid;
    DVektor mat1;
    DVektor mat2;

    mid.m_fX=0.0f;
    mid.m_fY=0.0f;
    mat1.m_fX=1.0f;
    mat1.m_fY=0.0f;
    mat2.m_fX=0.0f;
    mat2.m_fY=1.0f;

    g_pRender->Render( g_olBL,
                       mid,
                       mat1,
                       mat2,
                       1.0f );
}


void RenderSpot()
{
    g_olSpot.GetObjekt( 0 )->SetColor( 240, 240, 240 );

    DVektor mid;
    DVektor mat1;
    DVektor mat2;

    mid.m_fX=0.0f;
    mid.m_fY=0.0f;
    mat1.m_fX=1.0f;
    mat1.m_fY=0.0f;
    mat2.m_fX=0.0f;
    mat2.m_fY=1.0f;

    g_pRender->Render( g_olSpot,
                       mid,
                       mat1,
                       mat2,
                       1.0f );
}

void RenderLL()
{
    ((CCircle*)(g_olLL.GetObjekt( 0 )))->SetParams( 0.15f, 0.5f, 0.3f );
    ((CCircle*)(g_olLL.GetObjekt( 1 )))->SetParams( 0.15f, -0.5f, -0.3f );

    DVektor mid;
    DVektor mat1;
    DVektor mat2;

    mid.m_fX=0.0f;
    mid.m_fY=0.0f;
    mat1.m_fX=1.0f;
    mat1.m_fY=0.0f;
    mat2.m_fX=0.0f;
    mat2.m_fY=1.0f;

    g_pRender->Render( g_olLL,
                       mid,
                       mat1,
                       mat2,
                       1.0f );
}

void RenderRL()
{

    ((CCircle*)(g_olRL.GetObjekt( 0 )))->SetParams( 0.05f, 0.3f, 0.24f);
    ((CCircle*)(g_olRL.GetObjekt( 1 )))->SetParams( 0.05f, 0.3f, -0.24f);
    ((CCircle*)(g_olRL.GetObjekt( 2 )))->SetParams( 0.05f, -0.3f, 0.24f);
    ((CCircle*)(g_olRL.GetObjekt( 3 )))->SetParams( 0.05f, -0.3f, -0.24f);
    float fS= sin( 0.55f );
    float fC= cos( 0.55f );
    ((CLine*)(g_olRL.GetObjekt( 4 )))->SetStart( 0.07f * fS , -0.09f - 0.07f * fC);
    ((CLine*)(g_olRL.GetObjekt( 4 )))->SetEnd( -0.07f * fS , -0.09f + 0.07f * fC);
    ((CLine*)(g_olRL.GetObjekt( 5 )))->SetStart( 0.07f * fS , 0.09f + 0.07f * fC);
    ((CLine*)(g_olRL.GetObjekt( 5 )))->SetEnd( -0.07f * fS , 0.09f - 0.07f * fC);

    DVektor mid;
    DVektor mat1;
    DVektor mat2;

    mid.m_fX=0.0f;
    mid.m_fY=0.0f;
    mat1.m_fX=1.0f;
    mat1.m_fY=0.0f;
    mat2.m_fX=0.0f;
    mat2.m_fY=1.0f;

    g_pRender->Render( g_olRL,
                       mid,
                       mat1,
                       mat2,
                       1.0f );
}

void RenderPulse()
{
    ((CCircle*)(g_olPulse.GetObjekt( 0 )))->SetParams( 0.8f, 0.0f, 0.8f);
    DVektor mid;
    DVektor mat1;
    DVektor mat2;

    mid.m_fX=0.0f;
    mid.m_fY=-0.3f;
    mat1.m_fX=1.0f;
    mat1.m_fY=0.0f;
    mat2.m_fX=0.0f;
    mat2.m_fY=1.0f;

    g_pRender->Render( g_olPulse,
                       mid,
                       mat1,
                       mat2,
                       1.0f );
}

DWORD CPUBench( float& f )
{
    // stop Compiler from optimizing
    // (most compilers won't optimize if inline asm appears in a fkt)
    __asm__( "nop" );

    DWORD dwStart= timeGetTime();

    int siCount;
    float fTmp;

    for( siCount= 0, fTmp = 0.1f;
         siCount < 5000000;
         siCount++ )
    {
        int siRand= rand() & 1;

        if( siRand == 0 )
        {
            f+= fTmp* 0.07f;
            fTmp+= fTmp;
            fTmp-= 0.01*f;
        }
        else
        {
            f-= fTmp* 0.07f;
            fTmp-= fTmp * 0.5f;
            fTmp+= 0.01f  / ( 1.0f + f * f );
        }

        if (fTmp < -2.0f )
        {
            fTmp= -2.0f;
        }
        if (fTmp > 2.0f )
        {
            fTmp= 2.0f;
        }
    }


    return timeGetTime()- dwStart;
}

bool RunBenchmark( char* pcOptions )
{
    if ( !strstr ( pcOptions, "-bench") )
    {
        return false;
    }

    //prepare
    CreateObjects();
    g_prtMain= new CRenderTarget( 128, 128, 1.333f);
    g_pRender= new CRender( *g_prtMain );

    float fBenchHelp= 0.0f;
    DWORD dwCPU=  CPUBench( fBenchHelp );

    //warm up cache
    RenderXMas();

    dwTimeElapsed= 0;
    dwLastTimeLastTick= timeGetTime();

    //run 4 renderings for any scene == 32 frames
    {
        int siCountPass;
        int siCountScene;
        for( siCountScene= 0;
             siCountScene < 8;
             siCountScene++ )
            for( siCountPass= 0;
                 siCountPass < 4;
                 siCountPass++ )
            {
                switch( siCountScene )
                {
                case 0:
                    Render2D();
                    break;
                case 1:
                    RenderCC();
                    break;
                case 2:
                    RenderBL();
                    break;
                case 3:
                    RenderSpot();
                    break;
                case 4:
                    RenderLL();
                    break;
                case 5:
                    RenderRL();
                    break;
                case 6:
                    RenderPulse();
                    break;
                case 7:
                    RenderXMas();
                    break;
                }
            }
     }

    //print stats
    {
        const DWORD dwP2hCPUBench= 3533;
        const DWORD dwP2hRenderBench= 33908;

        DWORD dwTick= timeGetTime();
        dwTimeElapsed= timeGetTime() - dwLastTimeLastTick;

        std::ofstream ofs( "bench.txt", std::ios::out | std::ios::app );

        time_t t= time ( NULL );
        tm* pTM= localtime( &t );
        ofs << "Datum: " << pTM->tm_mday << "." << 1 + pTM->tm_mon << "." << 1900 + pTM->tm_year << "   ";
        ofs << "Uhrzeit: " << pTM->tm_hour << ":" << pTM->tm_min << "\n";

        float fCPURating= float(dwP2hCPUBench)/float(dwCPU);
        float fRenderRating= float(dwP2hRenderBench)/float(dwTimeElapsed);

        ofs << "Render Dauer: " << dwTimeElapsed << " ms   Rating: " << fRenderRating << " P2h-Marks";
        ofs << " (=" << 32000.0f/float(dwTimeElapsed) << " fps)\n";
        ofs << "CPUBench Dauer: " << dwCPU << " ms   Rating: " << fCPURating << " P2h-Marks\n";
        ofs << "Ratingkoeffizient: " << fRenderRating/fCPURating << "\n";
        ofs << "\n";
    }

	// Shutdown
    DestroyObjects();
    delete g_prtMain;
    delete g_pRender;

    return true;
}

bool RunShot( char* pcOptions )
{
    if ( !strstr ( pcOptions, "-shot") )
    {
        return false;
    }

    CreateObjects();
    g_prtMain= new CRenderTarget( 1024, 768, 1.0f);
    g_pRender= new CRender( *g_prtMain );

    if ( strstr ( pcOptions, "-shot1") )
    {
        Render2D();
        Screenshot("2Dlogo.raw");
    }
    if ( strstr ( pcOptions, "-shot2") )
    {
        RenderCC();
        Screenshot("ColorCircles.raw");
    }
    if ( strstr ( pcOptions, "-shot3") )
    {
        RenderBL();
        Screenshot("Boxes.raw");
    }
    if ( strstr ( pcOptions, "-shot4") )
    {
        RenderSpot();
        Screenshot("Spotlight.raw");
    }
    if ( strstr ( pcOptions, "-shot5") )
    {
        RenderLL();
        Screenshot("Shadow1.raw");
    }
    if ( strstr ( pcOptions, "-shot6") )
    {
        RenderRL();
        Screenshot("Shadow2.raw");
    }
    if ( strstr ( pcOptions, "-shot7") )
    {
        RenderPulse();
        Screenshot("Shadow3.raw");
    }
    if ( strstr ( pcOptions, "-shot8") )
    {
        RenderXMas();
        Screenshot("XMas.raw");
    }

    DestroyObjects();
    delete g_prtMain;
    delete g_pRender;

    return true;
}
void checkOptions (char* pcOptions)
{
    if ( strstr ( pcOptions, "-i") )
    {
        bInterpolated= false;
    }

    if ( strstr ( pcOptions, "-b16") )
    {
        siBitsPerPixel= 16;
    }

    if ( strstr ( pcOptions, "-s1") )
    {
        fPictureSize*=0.75f;
    }
    if ( strstr ( pcOptions, "-s2") )
    {
        fPictureSize*=0.5f;
    }
    if ( strstr ( pcOptions, "-s3") )
    {
        fPictureSize*=0.33f;
    }
    if ( strstr ( pcOptions, "-s4") )
    {
        fPictureSize*=0.25f;
    }

    if ( strstr ( pcOptions, "-t1") )
    {
        siTextureSize= 32;
    }
    if ( strstr ( pcOptions, "-t2") )
    {
        siTextureSize= 64;
    }
    if ( strstr ( pcOptions, "-t3") )
    {
        siTextureSize= 128;
    }
    if ( strstr ( pcOptions, "-t4") )
    {
        siTextureSize= 256;
    }
    if ( strstr ( pcOptions, "-t5") )
    {
        siTextureSize= 512;
    }

    if ( strstr ( pcOptions, "-r1") )
    {
        siScreenSizeX= 320;
        siScreenSizeY= 240;
    }
    if ( strstr ( pcOptions, "-r2") )
    {
        siScreenSizeX= 400;
        siScreenSizeY= 300;
    }
    if ( strstr ( pcOptions, "-r3") )
    {
        siScreenSizeX= 640;
        siScreenSizeY= 480;
    }
    if ( strstr ( pcOptions, "-r4") )
    {
        siScreenSizeX= 800;
        siScreenSizeY= 600;
    }
    if ( strstr ( pcOptions, "-r5") )
    {
        siScreenSizeX= 1024;
        siScreenSizeY= 768;
    }

}

int WINAPI WinMain(	HINSTANCE	hInstance,			// Instance
					HINSTANCE	hPrevInstance,		// Previous Instance
					LPSTR		lpCmdLine,			// Command Line Parameters
					int			nCmdShow)			// Window Show State
{
	MSG		msg;									// Windows Message Structure
	BOOL	done=FALSE;								// Bool Variable To Exit Loop

    siScreenSizeX= 640;
    siScreenSizeY= 480;
    siTextureSize= 64;
    fPictureSize= 1.625f;
    siBitsPerPixel= 32;
    bInterpolated= true;

    checkOptions( lpCmdLine );

    if( RunBenchmark( lpCmdLine ) )
    {
        return 0;
    }

    if( RunShot( lpCmdLine ) )
    {
        return 0;
    }

	// Create Our OpenGL Window
	if (!CreateGLWindow("ZweiD",siScreenSizeX,siScreenSizeY,siBitsPerPixel,true))
	{
		return 0;									// Quit If Window Was Not Created
	}

    CreateObjects();
    g_prtMain= new CRenderTarget(siTextureSize, siTextureSize, 1.333f);
    g_pRender= new CRender( *g_prtMain );

    dwTimeElapsed= 0;
    dwLastTimeLastTick= timeGetTime();

	while(!done)									// Loop That Runs While done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Is There A Message Waiting?
		{
			if (msg.message==WM_QUIT)				// Have We Received A Quit Message?
			{
				done=TRUE;							// If So done=TRUE
			}
			else									// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);				// Translate The Message
				DispatchMessage(&msg);				// Dispatch The Message
			}
		}
		else										// If There Are No Messages
		{
            DWORD dwTick= timeGetTime();
            dwTimeElapsed+= dwTick - dwLastTimeLastTick;
            dwLastTimeLastTick= dwTick;

			// Draw The Scene.  Watch For ESC Key And Quit Messages From DrawGLScene()
			if ((active && !DrawGLScene()) )	// Active?  Was There A Quit Received?
			{
				done=TRUE;							// ESC or DrawGLScene Signalled A Quit
			}
			else									// Not Time To Quit, Update Screen
			{
				SwapBuffers(hDC);					// Swap Buffers (Double Buffering)
			}
		}
	}

	// Shutdown
	KillGLWindow();									// Kill The Window
    DestroyObjects();
    delete g_prtMain;
    delete g_pRender;
	return (msg.wParam);							// Exit The Program
}

/*int STDCALL
WinMain (HINSTANCE hInst, HINSTANCE hPrev, LPSTR lpCmd, int nShow)
{
    DVektor mid;
    DVektor mat1;
    DVektor mat2;

    mid.m_fX=0.0f;
    mid.m_fY=0.0f;
    mat1.m_fX=1.0f;
    mat1.m_fY=0.0f;
    mat2.m_fX=0.0f;
    mat2.m_fY=1.0f;

    CreateObjects();

    g_Render.Render( g_olMain,
                     mid,
                     mat1,
                     mat2,
                     4.0f );
    Screenshot("test.raw");

    DestroyObjects();

    return 0;
} */
